# MTAC Upgrade Utility

This Utility allows upgrading the FPGA firmware on the MTAC-LoRa 1.5 rev c cards. 
It currently supports the following versions:
- v28 (TX Filter, Spectral Scan)
- v31 (TX Filter, Spectral Scan)

## Getting Started

These instructions will get you to upgrade the FPGA on a MTAC-LoRa 1.5 rev c card.

## Prerequisites

MultiConnect Conduit and MTAC-LoRa 1.5 rev c card or MultiConnect Access Point.

## Installing

```
scp <files> <device ip address>
tar -xvf <files>
ssh <device ip address>
chmod +x mtac_upgrade
```

## Usage
Please stop any processes that try to access the MTAC-LoRa card. For example, the LoRa Network Server and the LoRa Packet Forwarder or other third-party packet forwarders (e.g. Loriot, TTN, Actility, Senet, Orbiwise, etc.). The utility will check for open files on spidev and will not run if it finds any to prevent multiple access.

### Example
```
./mtac_upgrade -h                       See all available options and examples
./mtac_upgrade -c                  		Check existing FPGA version
./mtac_upgrade -i <upgrade file>        Upgrade the FPGA on the default port using the file specified
./mtac_upgrade -p 2 -i <upgrade file>   Upgrade the FPGA on ap2 using the file specified
./mtac_upgrade                          Upgrade the FPGA on the default port and upgrade file
```
### Options
```
 -c        Check Existing MTAC Verson
 -i        Specify input file. Default is mtcdt-fpga-v31.hex for a MultiConnect Conduit & mtcap-fpga-v31.hex for MultiConnect Access Point
 -p        Specify port 1 or 2. Only required for a MultiConnect Conduit when dual cards are installed
 -s        Print Supported FPGA versions
```

## Authors

* **Harsh Sharma** - Initial work

## Acknowledgments

* **Tim Barr** - Hardware design reference

